//+------------------------------------------------------------------+
//|                                                  HLR_Expert_.mq4 |
//|                      Copyright  2005, MetaQuotes Software Corp. |
//|                                       http://www.metaquotes.net/ |
//+------------------------------------------------------------------+
//
extern double Lots        = 0.1;
//
extern bool   LastBarOnly = true; 
extern int    Range       = 24; 
extern double Level_Bot   = 0.2; 
extern double Level_Mid   = 0.5; 
extern double Level_Top   = 0.8; 
// 
static datetime prev_time; 
static int MAGICMA; 
static double hlr_cur, hlr_prv; 
//+------------------------------------------------------------------+
//| Calculate open positions                                         |
//+------------------------------------------------------------------+
int CalculateCurrentOrders(string symbol)
 {
  int buys = 0, sells = 0;
 //----
  for (int i = OrdersTotal() - 1; i >= 0; i--)
   {
    if (OrderSelect(i, SELECT_BY_POS,MODE_TRADES) == true) 
     {
      if ((OrderSymbol() == Symbol()) && (OrderMagicNumber() == MAGICMA))
       {
        if (OrderType() == OP_BUY)  { buys++;  } 
        if (OrderType() == OP_SELL) { sells++; }
       }
     }
   }
 //---- return orders volume
  if (buys > 0) { return(buys);   } 
  else          { return(-sells); }
 }
//+------------------------------------------------------------------+
//| Check for open order conditions                                  |
//+------------------------------------------------------------------+
void CheckForOpen()
 { 
  int res;
 //----
  if ((hlr_prv == EMPTY_VALUE) || (hlr_cur == EMPTY_VALUE)) 
   {  }
 //---- sell conditions
  if ((hlr_prv > Level_Top) && (hlr_cur < Level_Top)) 
   { res = OrderSend(Symbol(), OP_SELL, Lots, Bid, 3, 0, 0, "", MAGICMA, 0, Red); }
 //---- buy conditions
  if ((hlr_prv < Level_Bot) && (hlr_cur > Level_Bot)) 
   { res = OrderSend(Symbol(), OP_BUY, Lots, Ask, 3, 0, 0, "", MAGICMA, 0, Blue); }
 //----
  return; 
 }
//+------------------------------------------------------------------+
//| Check for close order conditions                                 |
//+------------------------------------------------------------------+
void CheckForClose()
 { 
 //----
  for (int i = OrdersTotal() - 1; i >= 0; i--) 
   {
    if ((OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) == true) 
     {
      if ((OrderMagicNumber() == MAGICMA) && (OrderSymbol() == Symbol())) 
       {
        //---- check order type 
        if (OrderType() == OP_BUY) 
         { 
          if ((hlr_prv > Level_Mid) && (hlr_cur < Level_Mid)) 
           { OrderClose(OrderTicket(), OrderLots(), Bid, 3, Aqua); } 
         } 
        //----
        if (OrderType() == OP_SELL)
         { 
          if ((hlr_prv < Level_Mid) && (hlr_cur > Level_Mid)) 
           { OrderClose(OrderTicket(), OrderLots(), Ask, 3, Magenta); } 
         } 
       }
     }
   }  
 //---- 
  return; 
 }
//+------------------------------------------------------------------+
//| Start function                                                   |
//+------------------------------------------------------------------+
void start()
 { 
  static int sh_cnt = 0; 
  //
  string file_name;
 //---- check for history and trading
  if ((Bars < 100) || (IsTradeAllowed() == false)) { return; } 
 //---- go trading only for first tiks of new bar
  if (prev_time == Time[0]) { return; } 
 //----
  hlr_cur = iCustom(NULL, 0, "HLR_", LastBarOnly, Range, 0, 0); 
 //---- 
  if (IsVisualMode() == true)
   {
    Comment("hlr_cur = ", hlr_cur, "; hlr_prv = ", hlr_prv); 
 //----
    if ((MathAbs(hlr_prv) > 1) || (MathAbs(hlr_cur) > 1)) 
     { 
      sh_cnt++; 
      file_name = "error_" + DoubleToStr(sh_cnt, 0) + ".gif"; 
      WindowScreenShot(file_name, 800, 600); 
     } 
   }
 //---- calculate open orders by current symbol
  if (CalculateCurrentOrders(Symbol()) == 0) { CheckForOpen();  } 
  else                                       { CheckForClose(); } 
 //----
  hlr_prv = hlr_cur; 
 //----
  prev_time = Time[0]; 
 //----
  return; 
 }
//
//+------------------------------------------------------------------+
//| Init function                                                    |
//+------------------------------------------------------------------+
void init() 
 { 
  MathSrand(TimeLocal()); 
 //---- 
  prev_time = Time[0]; 
 //----
  MAGICMA = AccountNumber() + MathRand(); 
  Print("MAGICMA = ", MAGICMA); 
 //----
  return; 
 } 
//+------------------------------------------------------------------+